// A Bison parser, made by GNU Bison 3.7.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 31 "src/parser.yy"

#include <iostream>

#include "driver.h"

void yyerror(bpftrace::Driver &driver, const char *s);

#line 49 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"


#include "parser.tab.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 4 "src/parser.yy"
namespace  bpftrace  {
#line 147 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"

  /// Build a parser object.
   Parser :: Parser  (bpftrace::Driver &driver_yyarg, void *yyscanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

   Parser ::~ Parser  ()
  {}

   Parser ::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/



  // by_state.
   Parser ::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

   Parser ::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
   Parser ::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
   Parser ::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

   Parser ::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

   Parser ::symbol_kind_type
   Parser ::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

   Parser ::stack_symbol_type::stack_symbol_type ()
  {}

   Parser ::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.YY_MOVE_OR_COPY< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.YY_MOVE_OR_COPY< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.YY_MOVE_OR_COPY< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_pre_post_op: // pre_post_op
      case symbol_kind::S_map_or_var: // map_or_var
        value.YY_MOVE_OR_COPY< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.YY_MOVE_OR_COPY< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.YY_MOVE_OR_COPY< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.YY_MOVE_OR_COPY< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.YY_MOVE_OR_COPY< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.YY_MOVE_OR_COPY< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.YY_MOVE_OR_COPY< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes: // probes
        value.YY_MOVE_OR_COPY< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_semicolon_ended_stmt: // semicolon_ended_stmt
      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_compound_assignment: // compound_assignment
        value.YY_MOVE_OR_COPY< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmts: // stmts
      case symbol_kind::S_block_or_if: // block_or_if
        value.YY_MOVE_OR_COPY< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ternary: // ternary
        value.YY_MOVE_OR_COPY< ast::Ternary * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.YY_MOVE_OR_COPY< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.YY_MOVE_OR_COPY< long > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

   Parser ::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_pre_post_op: // pre_post_op
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes: // probes
        value.move< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_semicolon_ended_stmt: // semicolon_ended_stmt
      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_compound_assignment: // compound_assignment
        value.move< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmts: // stmts
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ternary: // ternary
        value.move< ast::Ternary * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< long > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.move< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
   Parser ::stack_symbol_type&
   Parser ::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.copy< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.copy< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.copy< ast::Call * > (that.value);
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_pre_post_op: // pre_post_op
      case symbol_kind::S_map_or_var: // map_or_var
        value.copy< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.copy< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.copy< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.copy< ast::Map * > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.copy< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.copy< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.copy< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_probes: // probes
        value.copy< ast::ProbeList * > (that.value);
        break;

      case symbol_kind::S_semicolon_ended_stmt: // semicolon_ended_stmt
      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_compound_assignment: // compound_assignment
        value.copy< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmts: // stmts
      case symbol_kind::S_block_or_if: // block_or_if
        value.copy< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_ternary: // ternary
        value.copy< ast::Ternary * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.copy< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.copy< long > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

   Parser ::stack_symbol_type&
   Parser ::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (that.value);
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_pre_post_op: // pre_post_op
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_probes: // probes
        value.move< ast::ProbeList * > (that.value);
        break;

      case symbol_kind::S_semicolon_ended_stmt: // semicolon_ended_stmt
      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_compound_assignment: // compound_assignment
        value.move< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmts: // stmts
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_ternary: // ternary
        value.move< ast::Ternary * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< long > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
   Parser ::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
   Parser ::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YYUSE (yykind);
        yyo << ')';
      }
  }
#endif

  void
   Parser ::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
   Parser ::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
   Parser ::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
   Parser ::debug_stream () const
  {
    return *yycdebug_;
  }

  void
   Parser ::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


   Parser ::debug_level_type
   Parser ::debug_level () const
  {
    return yydebug_;
  }

  void
   Parser ::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

   Parser ::state_type
   Parser ::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
   Parser ::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
   Parser ::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
   Parser ::operator() ()
  {
    return parse ();
  }

  int
   Parser ::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_attach_point: // attach_point
        yylhs.value.emplace< ast::AttachPoint * > ();
        break;

      case symbol_kind::S_attach_points: // attach_points
        yylhs.value.emplace< ast::AttachPointList * > ();
        break;

      case symbol_kind::S_call: // call
        yylhs.value.emplace< ast::Call * > ();
        break;

      case symbol_kind::S_expr: // expr
      case symbol_kind::S_pre_post_op: // pre_post_op
      case symbol_kind::S_map_or_var: // map_or_var
        yylhs.value.emplace< ast::Expression * > ();
        break;

      case symbol_kind::S_vargs: // vargs
        yylhs.value.emplace< ast::ExpressionList * > ();
        break;

      case symbol_kind::S_int: // int
        yylhs.value.emplace< ast::Integer * > ();
        break;

      case symbol_kind::S_map: // map
        yylhs.value.emplace< ast::Map * > ();
        break;

      case symbol_kind::S_param: // param
        yylhs.value.emplace< ast::PositionalParameter * > ();
        break;

      case symbol_kind::S_pred: // pred
        yylhs.value.emplace< ast::Predicate * > ();
        break;

      case symbol_kind::S_probe: // probe
        yylhs.value.emplace< ast::Probe * > ();
        break;

      case symbol_kind::S_probes: // probes
        yylhs.value.emplace< ast::ProbeList * > ();
        break;

      case symbol_kind::S_semicolon_ended_stmt: // semicolon_ended_stmt
      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_compound_assignment: // compound_assignment
        yylhs.value.emplace< ast::Statement * > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmts: // stmts
      case symbol_kind::S_block_or_if: // block_or_if
        yylhs.value.emplace< ast::StatementList * > ();
        break;

      case symbol_kind::S_ternary: // ternary
        yylhs.value.emplace< ast::Ternary * > ();
        break;

      case symbol_kind::S_var: // var
        yylhs.value.emplace< ast::Variable * > ();
        break;

      case symbol_kind::S_INT: // "integer"
        yylhs.value.emplace< long > ();
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        yylhs.value.emplace< std::string > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // program: c_definitions probes
#line 157 "src/parser.yy"
                               { driver.root_ = new ast::Program(yystack_[1].value.as < std::string > (), yystack_[0].value.as < ast::ProbeList * > ()); }
#line 1007 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 3: // c_definitions: "preprocessor directive" c_definitions
#line 160 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\n" + yystack_[0].value.as < std::string > (); }
#line 1013 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 4: // c_definitions: "struct definition" c_definitions
#line 161 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1019 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 5: // c_definitions: "enum" c_definitions
#line 162 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1025 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 6: // c_definitions: %empty
#line 163 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = std::string(); }
#line 1031 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 7: // probes: probes probe
#line 166 "src/parser.yy"
                      { yylhs.value.as < ast::ProbeList * > () = yystack_[1].value.as < ast::ProbeList * > (); yystack_[1].value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1037 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 8: // probes: probe
#line 167 "src/parser.yy"
                      { yylhs.value.as < ast::ProbeList * > () = new ast::ProbeList; yylhs.value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1043 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 9: // probe: attach_points pred block
#line 170 "src/parser.yy"
                                 { if (!driver.listing_)
                                     yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[2].value.as < ast::AttachPointList * > (), yystack_[1].value.as < ast::Predicate * > (), yystack_[0].value.as < ast::StatementList * > ());
                                   else
                                   {
                                     error(yylhs.location, "unexpected listing query format");
                                     YYERROR;
                                   }
                                 }
#line 1056 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 10: // probe: attach_points "end of file"
#line 178 "src/parser.yy"
                          { if (driver.listing_)
                              yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[1].value.as < ast::AttachPointList * > (), nullptr, nullptr);
                            else
                            {
                              error(yylhs.location, "unexpected end of file, expected {");
                              YYERROR;
                            }
                          }
#line 1069 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 11: // attach_points: attach_points "," attach_point
#line 188 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = yystack_[2].value.as < ast::AttachPointList * > (); yystack_[2].value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1075 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 12: // attach_points: attach_point
#line 189 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = new ast::AttachPointList; yylhs.value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1081 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 13: // attach_point: attach_point_def
#line 192 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1087 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 14: // attach_point_def: attach_point_def ident
#line 195 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1093 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 15: // attach_point_def: attach_point_def "string"
#line 199 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\"" + std::regex_replace(yystack_[0].value.as < std::string > (), std::regex("\""), "\\\"") + "\""; }
#line 1099 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 16: // attach_point_def: attach_point_def "path"
#line 200 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1105 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 17: // attach_point_def: attach_point_def "integer"
#line 201 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + std::to_string(yystack_[0].value.as < long > ()); }
#line 1111 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 18: // attach_point_def: attach_point_def ":"
#line 202 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ":"; }
#line 1117 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 19: // attach_point_def: attach_point_def "."
#line 203 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "."; }
#line 1123 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 20: // attach_point_def: attach_point_def "+"
#line 204 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "+"; }
#line 1129 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 21: // attach_point_def: attach_point_def "*"
#line 205 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "*"; }
#line 1135 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 22: // attach_point_def: attach_point_def "["
#line 206 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "["; }
#line 1141 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 23: // attach_point_def: attach_point_def "]"
#line 207 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "]"; }
#line 1147 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 24: // attach_point_def: attach_point_def param
#line 208 "src/parser.yy"
                                             {
                                               if (yystack_[0].value.as < ast::PositionalParameter * > ()->ptype != PositionalParameterType::positional)
                                               {
                                                  error(yylhs.location, "Not a positional parameter");
                                                  YYERROR;
                                               }

                                               // "Un-parse" the positional parameter back into text so
                                               // we can give it to the AttachPointParser. This is kind of
                                               // a hack but there doesn't look to be any other way.
                                               yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "$" + std::to_string(yystack_[0].value.as < ast::PositionalParameter * > ()->n);
                                               delete yystack_[0].value.as < ast::PositionalParameter * > ();
                                             }
#line 1165 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 25: // attach_point_def: %empty
#line 221 "src/parser.yy"
                                             { yylhs.value.as < std::string > () = ""; }
#line 1171 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 26: // pred: "/" expr "end predicate"
#line 224 "src/parser.yy"
                        { yylhs.value.as < ast::Predicate * > () = new ast::Predicate(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 1177 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 27: // pred: %empty
#line 225 "src/parser.yy"
                        { yylhs.value.as < ast::Predicate * > () = nullptr; }
#line 1183 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 28: // ternary: expr "?" expr ":" expr
#line 228 "src/parser.yy"
                                    { yylhs.value.as < ast::Ternary * > () = new ast::Ternary(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 1189 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 29: // param: "positional parameter"
#line 231 "src/parser.yy"
                   {
                     try {
                       long n = std::stol(yystack_[0].value.as < std::string > ().substr(1, yystack_[0].value.as < std::string > ().size()-1));
                       if (n == 0) throw std::exception();
                       yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::positional, n, yylhs.location);
                     } catch (std::exception const& e) {
                       error(yystack_[0].location, "param " + yystack_[0].value.as < std::string > () + " is out of integer range [1, " +
                             std::to_string(std::numeric_limits<long>::max()) + "]");
                       YYERROR;
                     }
                   }
#line 1205 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 30: // param: "$#"
#line 242 "src/parser.yy"
                   { yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::count, 0, yylhs.location); }
#line 1211 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 31: // block: "{" stmts "}"
#line 245 "src/parser.yy"
                          { yylhs.value.as < ast::StatementList * > () = yystack_[1].value.as < ast::StatementList * > (); }
#line 1217 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 32: // semicolon_ended_stmt: stmt ";"
#line 248 "src/parser.yy"
                                { yylhs.value.as < ast::Statement * > () = yystack_[1].value.as < ast::Statement * > (); }
#line 1223 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 33: // stmts: semicolon_ended_stmt stmts
#line 251 "src/parser.yy"
                                   { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[1].value.as < ast::Statement * > ()); }
#line 1229 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 34: // stmts: block_stmt stmts
#line 252 "src/parser.yy"
                                   { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[1].value.as < ast::Statement * > ()); }
#line 1235 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 35: // stmts: stmt
#line 253 "src/parser.yy"
                                   { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->push_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1241 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 36: // stmts: %empty
#line 254 "src/parser.yy"
                                   { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; }
#line 1247 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 37: // block_stmt: if_stmt
#line 257 "src/parser.yy"
                                      { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1253 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 38: // block_stmt: jump_stmt
#line 258 "src/parser.yy"
                                      { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1259 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 39: // block_stmt: loop_stmt
#line 259 "src/parser.yy"
                                      { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1265 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 40: // jump_stmt: "break"
#line 262 "src/parser.yy"
                      { yylhs.value.as < ast::Statement * > () = new ast::Jump(token::BREAK, yylhs.location); }
#line 1271 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 41: // jump_stmt: "continue"
#line 263 "src/parser.yy"
                      { yylhs.value.as < ast::Statement * > () = new ast::Jump(token::CONTINUE, yylhs.location); }
#line 1277 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 42: // jump_stmt: "return"
#line 264 "src/parser.yy"
                      { yylhs.value.as < ast::Statement * > () = new ast::Jump(token::RETURN, yylhs.location); }
#line 1283 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 43: // loop_stmt: "unroll" "(" int ")" block
#line 267 "src/parser.yy"
                                                  { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::Integer * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1289 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 44: // loop_stmt: "unroll" "(" param ")" block
#line 268 "src/parser.yy"
                                                  { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::PositionalParameter * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1295 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 45: // loop_stmt: "while" "(" expr ")" block
#line 269 "src/parser.yy"
                                                  { yylhs.value.as < ast::Statement * > () = new ast::While(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location); }
#line 1301 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 46: // if_stmt: "if" "(" expr ")" block
#line 272 "src/parser.yy"
                                                 { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1307 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 47: // if_stmt: "if" "(" expr ")" block "else" block_or_if
#line 273 "src/parser.yy"
                                                 { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::StatementList * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1313 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 48: // block_or_if: block
#line 276 "src/parser.yy"
                           { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); }
#line 1319 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 49: // block_or_if: if_stmt
#line 277 "src/parser.yy"
                           { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->emplace_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1325 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 50: // stmt: expr
#line 280 "src/parser.yy"
                           { yylhs.value.as < ast::Statement * > () = new ast::ExprStatement(yystack_[0].value.as < ast::Expression * > (), yystack_[0].location); }
#line 1331 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 51: // stmt: compound_assignment
#line 281 "src/parser.yy"
                           { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1337 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 52: // stmt: jump_stmt
#line 282 "src/parser.yy"
                           { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1343 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 53: // stmt: map "=" expr
#line 283 "src/parser.yy"
                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 1349 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 54: // stmt: var "=" expr
#line 284 "src/parser.yy"
                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 1355 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 56: // compound_assignment: map "<<=" expr
#line 288 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::LEFT,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1361 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 57: // compound_assignment: var "<<=" expr
#line 289 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::LEFT,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1367 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 58: // compound_assignment: map ">>=" expr
#line 290 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1373 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 59: // compound_assignment: var ">>=" expr
#line 291 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1379 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 60: // compound_assignment: map "+=" expr
#line 292 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::PLUS,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1385 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 61: // compound_assignment: var "+=" expr
#line 293 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::PLUS,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1391 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 62: // compound_assignment: map "-=" expr
#line 294 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1397 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 63: // compound_assignment: var "-=" expr
#line 295 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1403 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 64: // compound_assignment: map "*=" expr
#line 296 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::MUL,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1409 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 65: // compound_assignment: var "*=" expr
#line 297 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::MUL,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1415 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 66: // compound_assignment: map "/=" expr
#line 298 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::DIV,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1421 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 67: // compound_assignment: var "/=" expr
#line 299 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::DIV,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1427 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 68: // compound_assignment: map "%=" expr
#line 300 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::MOD,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1433 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 69: // compound_assignment: var "%=" expr
#line 301 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::MOD,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1439 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 70: // compound_assignment: map "&=" expr
#line 302 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::BAND,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1445 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 71: // compound_assignment: var "&=" expr
#line 303 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::BAND,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1451 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 72: // compound_assignment: map "|=" expr
#line 304 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::BOR,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1457 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 73: // compound_assignment: var "|=" expr
#line 305 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::BOR,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1463 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 74: // compound_assignment: map "^=" expr
#line 306 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), new ast::Binop(yystack_[2].value.as < ast::Map * > (), token::BXOR,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1469 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 75: // compound_assignment: var "^=" expr
#line 307 "src/parser.yy"
                                           { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), new ast::Binop(yystack_[2].value.as < ast::Variable * > (), token::BXOR,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location), true, yylhs.location); }
#line 1475 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 76: // tuple_assignment: expr "." "integer" "=" expr
#line 310 "src/parser.yy"
                                         { error(yystack_[4].location + yystack_[0].location, "Tuples are immutable once created. Consider creating a new tuple and assigning it instead."); YYERROR; }
#line 1481 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 77: // int: "-" "integer"
#line 312 "src/parser.yy"
                   { yylhs.value.as < ast::Integer * > () = new ast::Integer((long)(~(unsigned long)(yystack_[0].value.as < long > ()) + 1), yylhs.location); }
#line 1487 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 78: // int: "integer"
#line 313 "src/parser.yy"
                   { yylhs.value.as < ast::Integer * > () = new ast::Integer(yystack_[0].value.as < long > (), yylhs.location); }
#line 1493 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 79: // expr: int
#line 316 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Integer * > (); }
#line 1499 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 80: // expr: "string"
#line 317 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::String(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1505 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 81: // expr: "builtin"
#line 318 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1511 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 82: // expr: "call_builtin"
#line 319 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1517 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 83: // expr: "identifier"
#line 320 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Identifier(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1523 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 84: // expr: "stack_mode"
#line 321 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::StackMode(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1529 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 85: // expr: ternary
#line 322 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Ternary * > (); }
#line 1535 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 86: // expr: param
#line 323 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::PositionalParameter * > (); }
#line 1541 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 87: // expr: map_or_var
#line 324 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1547 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 88: // expr: call
#line 325 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Call * > (); }
#line 1553 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 89: // expr: "(" expr ")"
#line 326 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[1].value.as < ast::Expression * > (); }
#line 1559 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 90: // expr: expr "==" expr
#line 327 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::EQ, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1565 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 91: // expr: expr "!=" expr
#line 328 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::NE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1571 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 92: // expr: expr "<=" expr
#line 329 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1577 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 93: // expr: expr ">=" expr
#line 330 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::GE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1583 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 94: // expr: expr "<" expr
#line 331 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1589 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 95: // expr: expr ">" expr
#line 332 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::GT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1595 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 96: // expr: expr "&&" expr
#line 333 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LAND,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1601 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 97: // expr: expr "||" expr
#line 334 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LOR,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1607 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 98: // expr: expr "<<" expr
#line 335 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LEFT,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1613 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 99: // expr: expr ">>" expr
#line 336 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1619 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 100: // expr: expr "+" expr
#line 337 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::PLUS,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1625 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 101: // expr: expr "-" expr
#line 338 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1631 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 102: // expr: expr "*" expr
#line 339 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MUL,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1637 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 103: // expr: expr "/" expr
#line 340 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::DIV,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1643 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 104: // expr: expr "%" expr
#line 341 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MOD,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1649 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 105: // expr: expr "&" expr
#line 342 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BAND,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1655 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 106: // expr: expr "|" expr
#line 343 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BOR,   yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1661 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 107: // expr: expr "^" expr
#line 344 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BXOR,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1667 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 108: // expr: "!" expr
#line 345 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::LNOT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1673 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 109: // expr: "~" expr
#line 346 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::BNOT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1679 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 110: // expr: "-" expr
#line 347 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1685 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 111: // expr: "*" expr
#line 348 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::MUL,  yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1691 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 112: // expr: expr "." ident
#line 349 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < std::string > (), yystack_[1].location); }
#line 1697 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 113: // expr: expr "." "integer"
#line 350 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < long > (), yystack_[0].location); }
#line 1703 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 114: // expr: expr "->" ident
#line 351 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(new ast::Unop(token::MUL, yystack_[2].value.as < ast::Expression * > (), yystack_[1].location), yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1709 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 115: // expr: expr "[" expr "]"
#line 352 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::ArrayAccess(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < ast::Expression * > (), yystack_[2].location + yystack_[0].location); }
#line 1715 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 116: // expr: "(" "identifier" ")" expr
#line 353 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[2].value.as < std::string > (), false, false, yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 1721 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 117: // expr: "(" "identifier" "*" ")" expr
#line 354 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[3].value.as < std::string > (), true, false, yystack_[0].value.as < ast::Expression * > (), yystack_[4].location + yystack_[1].location); }
#line 1727 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 118: // expr: "(" "identifier" "*" "*" ")" expr
#line 355 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[4].value.as < std::string > (), true, true, yystack_[0].value.as < ast::Expression * > (), yystack_[5].location + yystack_[1].location); }
#line 1733 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 119: // expr: "(" expr "," vargs ")"
#line 356 "src/parser.yy"
                                                {
                                                  auto args = new ast::ExpressionList;
                                                  args->emplace_back(yystack_[3].value.as < ast::Expression * > ());
                                                  args->insert(args->end(), yystack_[1].value.as < ast::ExpressionList * > ()->begin(), yystack_[1].value.as < ast::ExpressionList * > ()->end());
                                                  yylhs.value.as < ast::Expression * > () = new ast::Tuple(args, yylhs.location);
                                                }
#line 1744 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 120: // expr: pre_post_op
#line 362 "src/parser.yy"
                                                { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1750 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 121: // pre_post_op: map_or_var "++"
#line 365 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::INCREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1756 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 122: // pre_post_op: map_or_var "--"
#line 366 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::DECREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1762 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 123: // pre_post_op: "++" map_or_var
#line 367 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::INCREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1768 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 124: // pre_post_op: "--" map_or_var
#line 368 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::DECREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1774 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 125: // pre_post_op: ident "++"
#line 369 "src/parser.yy"
                                   { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1780 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 126: // pre_post_op: "++" ident
#line 370 "src/parser.yy"
                                   { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1786 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 127: // pre_post_op: ident "--"
#line 371 "src/parser.yy"
                                   { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1792 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 128: // pre_post_op: "--" ident
#line 372 "src/parser.yy"
                                   { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1798 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 129: // ident: "identifier"
#line 375 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1804 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 130: // ident: "builtin"
#line 376 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1810 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 131: // ident: "call"
#line 377 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1816 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 132: // ident: "call_builtin"
#line 378 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1822 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 133: // ident: "stack_mode"
#line 379 "src/parser.yy"
                      { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1828 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 134: // call: "call" "(" ")"
#line 382 "src/parser.yy"
                                    { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 1834 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 135: // call: "call" "(" vargs ")"
#line 383 "src/parser.yy"
                                    { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1840 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 136: // call: "call_builtin" "(" ")"
#line 384 "src/parser.yy"
                                    { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 1846 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 137: // call: "call_builtin" "(" vargs ")"
#line 385 "src/parser.yy"
                                    { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1852 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 138: // call: "identifier" "(" ")"
#line 386 "src/parser.yy"
                                    { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1858 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 139: // call: "identifier" "(" vargs ")"
#line 387 "src/parser.yy"
                                    { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1864 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 140: // call: "builtin" "(" ")"
#line 388 "src/parser.yy"
                                    { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1870 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 141: // call: "builtin" "(" vargs ")"
#line 389 "src/parser.yy"
                                    { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1876 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 142: // call: "stack_mode" "(" ")"
#line 390 "src/parser.yy"
                                    { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1882 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 143: // call: "stack_mode" "(" vargs ")"
#line 391 "src/parser.yy"
                                    { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1888 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 144: // map: "map"
#line 394 "src/parser.yy"
                        { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1894 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 145: // map: "map" "[" vargs "]"
#line 395 "src/parser.yy"
                        { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1900 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 146: // var: "variable"
#line 398 "src/parser.yy"
          { yylhs.value.as < ast::Variable * > () = new ast::Variable(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1906 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 147: // map_or_var: var
#line 401 "src/parser.yy"
                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Variable * > (); }
#line 1912 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 148: // map_or_var: map
#line 402 "src/parser.yy"
                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Map * > (); }
#line 1918 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 149: // vargs: vargs "," expr
#line 405 "src/parser.yy"
                       { yylhs.value.as < ast::ExpressionList * > () = yystack_[2].value.as < ast::ExpressionList * > (); yystack_[2].value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 1924 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;

  case 150: // vargs: expr
#line 406 "src/parser.yy"
                       { yylhs.value.as < ast::ExpressionList * > () = new ast::ExpressionList; yylhs.value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 1930 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"
    break;


#line 1934 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
   Parser ::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
   Parser ::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
   Parser ::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  //  Parser ::context.
   Parser ::context::context (const  Parser & yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
   Parser ::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        int yychecklim = yylast_ - yyn + 1;
        int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }



  int
   Parser ::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
   Parser ::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short  Parser ::yypact_ninf_ = -154;

  const short  Parser ::yytable_ninf_ = -134;

  const short
   Parser ::yypact_[] =
  {
      42,    42,    42,    42,    16,  -154,  -154,  -154,  -154,  -154,
      17,  -154,    19,  -154,   179,  -154,  -154,  -154,   453,    28,
    -154,  -154,  -154,  -154,  -154,  -154,  -154,  -154,  -154,  -154,
    -154,  -154,  -154,  -154,  -154,  -154,  -154,  -154,  -154,   492,
     134,   531,   134,   453,   453,   453,    26,    15,   118,   171,
    -154,    33,  -154,  -154,   175,  -154,  -154,  -154,   637,  -154,
      -9,  -154,  -154,  -154,    73,   219,  -154,   181,   598,  -154,
    -154,  -154,    56,  -154,  -154,    39,    39,    39,   258,   297,
     336,   375,   453,   414,   453,   453,  -154,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   163,   -24,  -154,  -154,  -154,
    -154,    55,    59,    81,  -154,  -154,  -154,   219,   140,   219,
     124,  -154,  -154,   145,  -154,  -154,   795,   551,   597,   453,
       2,  -154,   453,  -154,   834,    21,  -154,    79,  -154,   116,
    -154,   120,     7,  -154,   121,   676,    99,  1096,  1096,  1120,
    1120,     3,     3,  1120,  1120,   951,   912,    56,    56,    39,
      39,    39,  1064,   990,  1027,  -154,  -154,  -154,   453,   -10,
     453,  -154,  -154,  -154,  -154,   240,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,    39,   453,
     141,   122,  -154,   453,  -154,  -154,  -154,  -154,  -154,  -154,
     453,   716,   117,   178,   189,   756,   185,   834,   834,   834,
     834,   834,   834,   834,   834,   834,   834,   834,   834,   834,
     834,   834,   834,   834,   834,   834,   834,   834,   834,    39,
     453,  -154,   834,   873,    28,  -154,    28,    28,    28,   453,
      39,   150,  -154,  -154,  -154,   834,     9,  -154,  -154,  -154
  };

  const unsigned char
   Parser ::yydefact_[] =
  {
       6,     6,     6,     6,     0,    25,     3,     4,     5,     1,
      25,     8,    27,    12,    13,     7,    10,    25,     0,     0,
      18,    22,    23,    30,    20,    21,    19,   130,   131,   132,
     129,    16,    15,    29,    17,   133,    24,    14,    11,     0,
       0,     0,     0,     0,     0,     0,    81,   131,    82,    83,
      80,   144,   146,    78,    84,    85,    86,    79,     0,   120,
       0,    88,   148,   147,    87,    36,     9,    83,     0,   126,
     123,    77,   110,   128,   124,   111,   108,   109,     0,     0,
       0,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   125,   127,   121,
     122,     0,     0,     0,    42,    41,    40,    36,     0,    36,
      38,    39,    37,    35,    51,    55,    50,   148,   147,     0,
       0,    89,     0,   140,   150,     0,   134,     0,   136,     0,
     138,     0,     0,   142,     0,     0,     0,    90,    91,    92,
      93,    98,    99,    94,    95,    96,    97,   100,   101,   102,
     103,   104,   105,   106,   107,   113,   112,   114,     0,     0,
       0,    33,    31,    34,    32,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   116,     0,
       0,     0,   141,     0,   135,   137,   139,   145,   143,   115,
       0,     0,     0,     0,     0,     0,   113,    53,    56,    58,
      60,    62,    64,    66,    68,    70,    72,    74,    54,    57,
      59,    61,    63,    65,    67,    69,    71,    73,    75,   117,
       0,   119,   149,    28,     0,    77,     0,     0,     0,     0,
     118,    46,    44,    43,    45,    76,     0,    48,    49,    47
  };

  const short
   Parser ::yypgoto_[] =
  {
    -154,  -154,   152,  -154,   196,  -154,   192,  -154,  -154,  -154,
     -13,  -153,  -154,  -106,  -154,  -154,  -154,   -45,  -154,  -154,
    -154,  -154,    43,   -18,  -154,     8,  -154,   -63,   -62,    96,
     -74
  };

  const short
   Parser ::yydefgoto_[] =
  {
      -1,     4,     5,    10,    11,    12,    13,    14,    19,    55,
      56,    66,   117,   118,   119,   120,   121,   122,   259,   123,
     124,   125,    57,   134,    59,    60,    61,    62,    63,    64,
     135
  };

  const short
   Parser ::yytable_[] =
  {
      58,    36,   127,   128,    23,   137,   139,   141,   142,   144,
      84,   171,   199,   173,    65,   207,     9,    -2,   107,    16,
     203,    68,    37,    72,    79,    75,    76,    77,   212,    97,
     108,   202,    17,    65,   203,    78,    27,    28,    29,    30,
      82,    98,   200,    99,   100,   101,    84,   126,    69,    35,
      73,   105,   106,  -130,   127,   128,   127,   128,   201,   111,
      18,    33,    53,    84,   168,  -130,   145,   146,   169,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   105,   106,   204,
     170,   251,   203,   252,   253,   254,    99,   100,   101,   126,
     109,   126,   210,   257,   105,   106,    84,     1,     2,     3,
      85,   198,   110,   166,   167,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,   205,    80,   -52,   203,
     206,   208,   241,   203,   203,   203,    70,    98,    74,    99,
     100,   101,   102,   103,   104,  -132,   172,   105,   106,   174,
     211,   240,   215,     6,     7,     8,   213,  -132,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
      81,   239,    20,   166,    83,   242,    21,    22,   246,   245,
      81,   129,   243,    23,    27,    28,    29,    30,  -129,   247,
     249,   256,  -133,    51,    52,    24,    15,    35,  -129,    38,
    -129,   258,   214,     0,  -133,     0,     0,     0,     0,    25,
    -129,   130,   250,    27,    28,    29,    30,    26,    39,     0,
       0,   255,     0,    23,     0,   165,    35,     0,     0,    27,
      28,    29,    30,    31,     0,     0,    40,    32,     0,     0,
      33,    34,    35,     0,     0,     0,     0,    41,    42,    43,
       0,     0,     0,     0,     0,    44,    45,    39,   133,   111,
       0,   112,    23,     0,   113,     0,   114,   115,   116,    46,
      47,    48,    49,     0,     0,    40,     0,    50,    51,    52,
      33,    53,    54,     0,     0,     0,    41,    42,    43,     0,
      27,    28,    29,    30,    44,    45,    39,   136,     0,     0,
       0,    23,   216,    35,     0,     0,     0,     0,    46,    47,
      48,    49,     0,     0,    40,     0,    50,    51,    52,    33,
      53,    54,     0,     0,     0,    41,    42,    43,     0,     0,
       0,     0,     0,    44,    45,    39,   138,     0,     0,     0,
      23,     0,     0,     0,     0,     0,     0,    46,    47,    48,
      49,     0,     0,    40,     0,    50,    51,    52,    33,    53,
      54,     0,     0,     0,    41,    42,    43,     0,     0,     0,
       0,     0,    44,    45,    39,   140,     0,     0,     0,    23,
       0,     0,     0,     0,     0,     0,    46,    47,    48,    49,
       0,     0,    40,     0,    50,    51,    52,    33,    53,    54,
       0,     0,     0,    41,    42,    43,     0,     0,     0,     0,
       0,    44,    45,    39,   143,     0,     0,     0,    23,     0,
       0,     0,     0,     0,     0,    46,    47,    48,    49,     0,
       0,    40,     0,    50,    51,    52,    33,    53,    54,     0,
       0,     0,    41,    42,    43,     0,     0,     0,     0,     0,
      44,    45,    39,     0,     0,     0,     0,    23,     0,     0,
       0,     0,     0,     0,    46,    47,    48,    49,     0,     0,
      40,     0,    50,    51,    52,    33,    53,    54,     0,     0,
       0,    41,    42,    43,     0,     0,     0,     0,     0,    44,
      45,    39,     0,     0,     0,     0,    23,     0,     0,     0,
       0,     0,     0,    46,    47,    48,    49,     0,     0,    40,
       0,    50,    51,    52,    33,    53,    54,     0,     0,     0,
      41,    42,    43,     0,     0,     0,     0,     0,    44,    45,
      39,     0,     0,     0,     0,    23,     0,     0,     0,     0,
       0,     0,    46,    47,    48,    67,     0,     0,    40,     0,
      50,    51,    52,    33,    53,    54,   176,     0,     0,    41,
      42,    43,     0,     0,     0,     0,     0,    44,    45,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,     0,
       0,    46,    47,    48,    49,     0,     0,     0,     0,    50,
      51,    52,    33,    71,    54,    84,     0,     0,   131,    85,
       0,   132,   187,     0,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,     0,    98,     0,    99,   100,
     101,   102,   103,   104,    84,     0,   105,   106,    85,    86,
       0,     0,     0,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    98,     0,    99,   100,   101,
     102,   103,   104,    84,   209,   105,   106,    85,     0,     0,
       0,     0,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    98,     0,    99,   100,   101,   102,
     103,   104,     0,    84,   105,   106,   244,    85,     0,     0,
       0,     0,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    98,     0,    99,   100,   101,   102,
     103,   104,     0,    84,   105,   106,   248,    85,     0,     0,
       0,     0,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    98,     0,    99,   100,   101,   102,
     103,   104,    84,     0,   105,   106,    85,     0,     0,     0,
       0,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    98,     0,    99,   100,   101,   102,   103,
     104,    84,     0,   175,   106,    85,     0,     0,     0,     0,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    98,     0,    99,   100,   101,   102,   103,   104,
      84,     0,   105,   106,     0,     0,     0,     0,     0,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    98,     0,    99,   100,   101,   102,   103,   104,    84,
       0,   105,   106,     0,     0,     0,     0,     0,    87,    88,
      89,    90,    91,    92,    93,    94,    95,     0,    97,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      98,     0,    99,   100,   101,   102,   103,   104,    84,     0,
     105,   106,     0,     0,     0,     0,     0,    87,    88,    89,
      90,    91,    92,    93,    94,     0,     0,    97,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    98,
       0,    99,   100,   101,   102,   103,   104,    84,     0,   105,
     106,     0,     0,     0,     0,     0,    87,    88,    89,    90,
      91,    92,    93,    94,     0,     0,    97,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    98,     0,
      99,   100,   101,   102,    84,   104,     0,     0,   105,   106,
       0,     0,     0,    87,    88,    89,    90,    91,    92,    93,
      94,     0,     0,    97,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    98,     0,    99,   100,   101,
     102,    84,     0,     0,     0,   105,   106,     0,     0,     0,
      87,    88,    89,    90,    91,    92,    93,    94,     0,     0,
      97,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    98,    84,    99,   100,   101,     0,     0,     0,
       0,     0,   105,   106,    89,    90,    91,    92,    93,    94,
       0,     0,    97,     0,     0,     0,     0,    84,     0,     0,
       0,     0,     0,     0,    98,     0,    99,   100,   101,     0,
      91,    92,     0,     0,   105,   106,    97,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    98,     0,
      99,   100,   101,     0,     0,     0,     0,     0,   105,   106
  };

  const short
   Parser ::yycheck_[] =
  {
      18,    14,    65,    65,    14,    79,    80,    81,    82,    83,
       7,   117,    10,   119,     5,     8,     0,     0,    27,     0,
      13,    39,    14,    41,     9,    43,    44,    45,    38,    26,
      39,    10,    13,     5,    13,     9,    60,    61,    62,    63,
       7,    38,    40,    40,    41,    42,     7,    65,    40,    73,
      42,    48,    49,    27,   117,   117,   119,   119,   132,    50,
      41,    71,    72,     7,     9,    39,    84,    85,     9,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,    48,    49,    10,
       9,   244,    13,   246,   247,   248,    40,    41,    42,   117,
      27,   119,     3,   256,    48,    49,     7,    65,    66,    67,
      11,   129,    39,   105,   106,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    10,     9,     4,    13,
      10,    10,    10,    13,    13,    13,    40,    38,    42,    40,
      41,    42,    43,    44,    45,    27,     6,    48,    49,     4,
     168,    10,   170,     1,     2,     3,   169,    39,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
       9,   199,     3,   175,     9,   203,     7,     8,    10,    72,
       9,    10,   210,    14,    60,    61,    62,    63,    27,    10,
      15,    51,    27,    69,    70,    26,    10,    73,    27,    17,
      39,   256,   169,    -1,    39,    -1,    -1,    -1,    -1,    40,
      39,    40,   240,    60,    61,    62,    63,    48,     9,    -1,
      -1,   249,    -1,    14,    -1,    72,    73,    -1,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    27,    68,    -1,    -1,
      71,    72,    73,    -1,    -1,    -1,    -1,    38,    39,    40,
      -1,    -1,    -1,    -1,    -1,    46,    47,     9,    10,    50,
      -1,    52,    14,    -1,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    27,    -1,    68,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    38,    39,    40,    -1,
      60,    61,    62,    63,    46,    47,     9,    10,    -1,    -1,
      -1,    14,    72,    73,    -1,    -1,    -1,    -1,    60,    61,
      62,    63,    -1,    -1,    27,    -1,    68,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    38,    39,    40,    -1,    -1,
      -1,    -1,    -1,    46,    47,     9,    10,    -1,    -1,    -1,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,
      63,    -1,    -1,    27,    -1,    68,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    38,    39,    40,    -1,    -1,    -1,
      -1,    -1,    46,    47,     9,    10,    -1,    -1,    -1,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,
      -1,    -1,    27,    -1,    68,    69,    70,    71,    72,    73,
      -1,    -1,    -1,    38,    39,    40,    -1,    -1,    -1,    -1,
      -1,    46,    47,     9,    10,    -1,    -1,    -1,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,    -1,
      -1,    27,    -1,    68,    69,    70,    71,    72,    73,    -1,
      -1,    -1,    38,    39,    40,    -1,    -1,    -1,    -1,    -1,
      46,    47,     9,    -1,    -1,    -1,    -1,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    62,    63,    -1,    -1,
      27,    -1,    68,    69,    70,    71,    72,    73,    -1,    -1,
      -1,    38,    39,    40,    -1,    -1,    -1,    -1,    -1,    46,
      47,     9,    -1,    -1,    -1,    -1,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    62,    63,    -1,    -1,    27,
      -1,    68,    69,    70,    71,    72,    73,    -1,    -1,    -1,
      38,    39,    40,    -1,    -1,    -1,    -1,    -1,    46,    47,
       9,    -1,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    61,    62,    63,    -1,    -1,    27,    -1,
      68,    69,    70,    71,    72,    73,    15,    -1,    -1,    38,
      39,    40,    -1,    -1,    -1,    -1,    -1,    46,    47,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    -1,
      -1,    60,    61,    62,    63,    -1,    -1,    -1,    -1,    68,
      69,    70,    71,    72,    73,     7,    -1,    -1,    10,    11,
      -1,    13,    15,    -1,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    -1,    38,    -1,    40,    41,
      42,    43,    44,    45,     7,    -1,    48,    49,    11,    12,
      -1,    -1,    -1,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,
      43,    44,    45,     7,     8,    48,    49,    11,    -1,    -1,
      -1,    -1,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,    43,
      44,    45,    -1,     7,    48,    49,    10,    11,    -1,    -1,
      -1,    -1,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,    43,
      44,    45,    -1,     7,    48,    49,    10,    11,    -1,    -1,
      -1,    -1,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,    43,
      44,    45,     7,    -1,    48,    49,    11,    -1,    -1,    -1,
      -1,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    38,    -1,    40,    41,    42,    43,    44,
      45,     7,    -1,    48,    49,    11,    -1,    -1,    -1,    -1,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    38,    -1,    40,    41,    42,    43,    44,    45,
       7,    -1,    48,    49,    -1,    -1,    -1,    -1,    -1,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    38,    -1,    40,    41,    42,    43,    44,    45,     7,
      -1,    48,    49,    -1,    -1,    -1,    -1,    -1,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    -1,    26,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      38,    -1,    40,    41,    42,    43,    44,    45,     7,    -1,
      48,    49,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,
      19,    20,    21,    22,    23,    -1,    -1,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,
      -1,    40,    41,    42,    43,    44,    45,     7,    -1,    48,
      49,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,
      20,    21,    22,    23,    -1,    -1,    26,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,
      40,    41,    42,    43,     7,    45,    -1,    -1,    48,    49,
      -1,    -1,    -1,    16,    17,    18,    19,    20,    21,    22,
      23,    -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,
      43,     7,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,
      16,    17,    18,    19,    20,    21,    22,    23,    -1,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    38,     7,    40,    41,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    18,    19,    20,    21,    22,    23,
      -1,    -1,    26,    -1,    -1,    -1,    -1,     7,    -1,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,    -1,
      20,    21,    -1,    -1,    48,    49,    26,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,
      40,    41,    42,    -1,    -1,    -1,    -1,    -1,    48,    49
  };

  const signed char
   Parser ::yystos_[] =
  {
       0,    65,    66,    67,    77,    78,    78,    78,    78,     0,
      79,    80,    81,    82,    83,    80,     0,    13,    41,    84,
       3,     7,     8,    14,    26,    40,    48,    60,    61,    62,
      63,    64,    68,    71,    72,    73,    86,   101,    82,     9,
      27,    38,    39,    40,    46,    47,    60,    61,    62,    63,
      68,    69,    70,    72,    73,    85,    86,    98,    99,   100,
     101,   102,   103,   104,   105,     5,    87,    63,    99,   101,
     105,    72,    99,   101,   105,    99,    99,    99,     9,     9,
       9,     9,     7,     9,     7,    11,    12,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    38,    40,
      41,    42,    43,    44,    45,    48,    49,    27,    39,    27,
      39,    50,    52,    55,    57,    58,    59,    88,    89,    90,
      91,    92,    93,    95,    96,    97,    99,   103,   104,    10,
      40,    10,    13,    10,    99,   106,    10,   106,    10,   106,
      10,   106,   106,    10,   106,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    72,   101,   101,     9,     9,
       9,    89,     6,    89,     4,    48,    15,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    15,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    99,    10,
      40,   106,    10,    13,    10,    10,    10,     8,    10,     8,
       3,    99,    38,    86,    98,    99,    72,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      10,    10,    99,    99,    10,    72,    10,    10,    10,    15,
      99,    87,    87,    87,    87,    99,    51,    87,    93,    94
  };

  const signed char
   Parser ::yyr1_[] =
  {
       0,    76,    77,    78,    78,    78,    78,    79,    79,    80,
      80,    81,    81,    82,    83,    83,    83,    83,    83,    83,
      83,    83,    83,    83,    83,    83,    84,    84,    85,    86,
      86,    87,    88,    89,    89,    89,    89,    90,    90,    90,
      91,    91,    91,    92,    92,    92,    93,    93,    94,    94,
      95,    95,    95,    95,    95,    95,    96,    96,    96,    96,
      96,    96,    96,    96,    96,    96,    96,    96,    96,    96,
      96,    96,    96,    96,    96,    96,    97,    98,    98,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,   100,   100,   100,   100,   100,   100,   100,   100,   101,
     101,   101,   101,   101,   102,   102,   102,   102,   102,   102,
     102,   102,   102,   102,   103,   103,   104,   105,   105,   106,
     106
  };

  const signed char
   Parser ::yyr2_[] =
  {
       0,     2,     2,     2,     2,     2,     0,     2,     1,     3,
       2,     3,     1,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     0,     3,     0,     5,     1,
       1,     3,     2,     2,     2,     1,     0,     1,     1,     1,
       1,     1,     1,     5,     5,     5,     5,     7,     1,     1,
       1,     1,     1,     3,     3,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     5,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       2,     2,     3,     3,     3,     4,     4,     5,     6,     5,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     3,     4,     3,     4,     3,     4,
       3,     4,     3,     4,     1,     4,     1,     1,     1,     3,
       1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const  Parser ::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "\":\"", "\";\"",
  "\"{\"", "\"}\"", "\"[\"", "\"]\"", "\"(\"", "\")\"", "\"?\"",
  "\"end predicate\"", "\",\"", "\"$#\"", "\"=\"", "\"==\"", "\"!=\"",
  "\"<=\"", "\">=\"", "\"<<\"", "\">>\"", "\"<\"", "\">\"", "\"&&\"",
  "\"||\"", "\"+\"", "\"++\"", "\"<<=\"", "\">>=\"", "\"+=\"", "\"-=\"",
  "\"*=\"", "\"/=\"", "\"%=\"", "\"&=\"", "\"|=\"", "\"^=\"", "\"-\"",
  "\"--\"", "\"*\"", "\"/\"", "\"%\"", "\"&\"", "\"|\"", "\"^\"", "\"!\"",
  "\"~\"", "\".\"", "\"->\"", "\"if\"", "\"else\"", "\"unroll\"",
  "\"struct\"", "\"union\"", "\"while\"", "\"for\"", "\"return\"",
  "\"continue\"", "\"break\"", "\"builtin\"", "\"call\"",
  "\"call_builtin\"", "\"identifier\"", "\"path\"",
  "\"preprocessor directive\"", "\"struct definition\"", "\"enum\"",
  "\"string\"", "\"map\"", "\"variable\"", "\"positional parameter\"",
  "\"integer\"", "\"stack_mode\"", "DEREF", "CAST", "$accept", "program",
  "c_definitions", "probes", "probe", "attach_points", "attach_point",
  "attach_point_def", "pred", "ternary", "param", "block",
  "semicolon_ended_stmt", "stmts", "block_stmt", "jump_stmt", "loop_stmt",
  "if_stmt", "block_or_if", "stmt", "compound_assignment",
  "tuple_assignment", "int", "expr", "pre_post_op", "ident", "call", "map",
  "var", "map_or_var", "vargs", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
   Parser ::yyrline_[] =
  {
       0,   157,   157,   160,   161,   162,   163,   166,   167,   170,
     178,   188,   189,   192,   195,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   221,   224,   225,   228,   231,
     242,   245,   248,   251,   252,   253,   254,   257,   258,   259,
     262,   263,   264,   267,   268,   269,   272,   273,   276,   277,
     280,   281,   282,   283,   284,   285,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   310,   312,   313,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     362,   365,   366,   367,   368,   369,   370,   371,   372,   375,
     376,   377,   378,   379,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   394,   395,   398,   401,   402,   405,
     406
  };

  void
   Parser ::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
   Parser ::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 4 "src/parser.yy"
} //  bpftrace 
#line 2767 "/builddir/build/BUILD/bpftrace-0.12.1/s390x-redhat-linux-gnu/parser.tab.cc"

#line 409 "src/parser.yy"


void bpftrace::Parser::error(const location &l, const std::string &m)
{
  driver.error(l, m);
}
